#include <iostream>
#include <iomanip>

using namespace std;

void numberOfPlayers(bool& twoPlayers);
void choosePlayer(char& playerChoice);
void displayGameBoard(int xMoves, int oMoves);
bool moveAlreadyAtPosition(int currentMove, int allMoves);
int getMove(char playerChoice, char currentPlayer, int xMoves, int oMoves, bool twoPlayers);
int aiMove(int playerMoves, int aiMoves);
void applyMove(char currentPlayer, int currentMove, int& xMoves, int& oMoves);
void checkForWinner(bool& gameOver, int xMoves, int oMoves);


void main()
{
	int xMoves = 0;
	int oMoves = 0;
	char currentPlayer = 'X';
	char playerChoice = ' ';
	bool gameOver = false;
	bool twoPlayers = false;

	numberOfPlayers(twoPlayers);

	if (twoPlayers == false)
	{
		choosePlayer(playerChoice);
	}

	while (!gameOver)
	{
		displayGameBoard(xMoves, oMoves);

		int currentMove = getMove(playerChoice, currentPlayer, xMoves, oMoves, twoPlayers);

		applyMove(currentPlayer, currentMove, xMoves, oMoves );

		//change whose turn it is
		//(currentPlayer == 'X') ? currentPlayer = 'O' : currentPlayer = 'X';

		if (currentPlayer == 'X')
		{
			currentPlayer = 'O';
		}
		else
		{
			currentPlayer = 'X';
		}
		//check for a winner
		checkForWinner(gameOver, xMoves, oMoves);
	}

}

void numberOfPlayers(bool& twoPlayers)
{
	twoPlayers = false;
	int answer = 0;

	do
	{
		cout << "One or Two players?" << endl;
		cin >> answer;

		if (answer == 1 || answer == 2)
		{
			break;
		}
		else
		{
			cout << "Not a valid number" << endl;
		}
	} while (answer != 1 && answer != 2);

	if (answer == 2)
	{
		twoPlayers = true;
	}
}

void choosePlayer(char& playerChoice)
{

	bool validLetter = false;

	while (validLetter == false)
	{
		cout << "Would you like to be X's or O's?" << endl;
		cin >> playerChoice;

		if (playerChoice == 'x' || playerChoice == 'o')
		{
			validLetter = true;
		}
	}

	if (playerChoice == 'x')
	{
		cout << "You've chosen to play as X's\nThe computer will be O's" << endl;
	}
	else
	{
		cout << "You've chosen to play as O's\nThe computer will be X's" << endl;
	}
	cout << endl;
}

void displayGameBoard(int xMoves, int oMoves)
{
	//display the gameboard
	/*system("cls");*/
	for (int i = 1; i <= 9; i++)
	{
		if ((xMoves & (int)pow(2, i)) == pow(2, i))
		{
			cout << 'X';
		}
		else if ((oMoves & (int)pow(2, i)) == pow(2, i))
		{
			cout << 'O';
		}
		else
		{
			cout << i;
		}
		if (i == 1 || i == 2 || i == 4 || i == 5 || i == 7 || i == 8)
		{
			cout << "|";
		}
		else if (i != 9)
		{
			cout << "\n-----\n";
		}
	}
	cout << endl;
}

bool moveAlreadyAtPosition(int currentMove, int allMoves)
{
	bool result = false;

	if (((int)pow(2, currentMove) & allMoves) > 0)
	{
		result = true;
		cout << "Cheating is not allowed\n";
	}

	return result;
}

int getMove(char playerChoice, const char currentPlayer, int xMoves, int oMoves, bool twoPlayers)
{
	int currentMove = 0;
	if (twoPlayers || 
		(currentPlayer == 'X' && playerChoice == 'x') ||
		(currentPlayer == 'O' && playerChoice == 'o'))
	{
		cout << currentPlayer << "'s move" << endl;
		do
		{
			cout << ">";
			cin >> currentMove;
		} while (currentMove < 1 || currentMove > 9 ||
			moveAlreadyAtPosition(currentMove, xMoves | oMoves));
	}
	else if (playerChoice == 'x')
	{
		// o is the ai
		currentMove = aiMove(xMoves, oMoves);

	}
	else if (playerChoice == 'o')
	{
		// x is the ai
		currentMove = aiMove(oMoves, xMoves);
	}

	return currentMove;
}

int aiMove(int playerMoves, int aiMoves)
{
	int allMoves = playerMoves | aiMoves;
	int result = 0;
	//first row, first column, diagonal right
	if ((((aiMoves + 2) & 14) == 14 || ((aiMoves + 2) & 146) == 146 || ((aiMoves + 2) & 546) == 546) && !moveAlreadyAtPosition(1, allMoves))
	{
		result = 1;
	}
	else if ((((aiMoves + 4) & 14) == 14 || ((aiMoves + 4) & 292) == 292) && !moveAlreadyAtPosition(2, allMoves))
	{
		result = 2;
	}
	else if ((((aiMoves + 8) & 14) == 14 || ((aiMoves + 8) & 584) == 584 || ((aiMoves + 8) & 168) == 168) && !moveAlreadyAtPosition(3, allMoves))
	{
		result = 3;
	}
	else if ((((aiMoves + 16) & 146) == 146 || ((aiMoves + 16) & 112) == 112) && !moveAlreadyAtPosition(4, allMoves))
	{
		result = 4;
	}
	else if ((((aiMoves + 32) & 112) == 112 || ((aiMoves + 32) & 292) == 292 || ((aiMoves + 32) & 546) == 546 || ((aiMoves + 32) & 168) == 168) && !moveAlreadyAtPosition(5, allMoves))
	{
		result = 5;
	}
	else if ((((aiMoves + 64) & 112) == 12 || ((aiMoves + 64) & 584) == 584) && !moveAlreadyAtPosition(6, allMoves))
	{
		result = 6;
	}
	else if ((((aiMoves + 128) & 896) == 896 || ((aiMoves + 128) & 146) == 146 || ((aiMoves + 128) & 168) == 168) && !moveAlreadyAtPosition(7, allMoves))
	{
		result = 7;
	}
	else if ((((aiMoves + 256) & 292) == 292 || ((aiMoves + 256) & 896) == 896) && !moveAlreadyAtPosition(8, allMoves))
	{
		result = 8;
	}
	else if ((((aiMoves + 512) & 896) == 896 || ((aiMoves + 128) & 546) == 546 || ((aiMoves + 128) & 548) == 548) && !moveAlreadyAtPosition(9, allMoves))
	{
		result = 9;
	}
	else if ((((playerMoves + 2) & 14) == 14 || ((playerMoves + 2) & 146) == 146 || ((playerMoves + 2) & 546) == 546) && !moveAlreadyAtPosition(1, allMoves))
	{
		result = 1;
	}
	else if ((((playerMoves + 4) & 14) == 14 || ((playerMoves + 4) & 292) == 292) && !moveAlreadyAtPosition(2, allMoves))
	{
		result = 2;
	}
	else if ((((playerMoves + 8) & 14) == 14 || ((playerMoves + 8) & 584) == 584 || ((playerMoves + 8) & 168) == 168) && !moveAlreadyAtPosition(3, allMoves))
	{
		result = 3;
	}
	else if ((((playerMoves + 16) & 146) == 146 || ((playerMoves + 16) & 112) == 112) && !moveAlreadyAtPosition(4, allMoves))
	{
		result = 4;
	}
	else if ((((playerMoves + 32) & 112) == 112 || ((playerMoves + 32) & 292) == 292 || ((playerMoves + 32) & 546) == 546 || ((playerMoves + 32) & 168) == 168) && !moveAlreadyAtPosition(5, allMoves))
	{
		result = 5;
	}
	else if ((((playerMoves + 64) & 112) == 12 || ((playerMoves + 64) & 584) == 584) && !moveAlreadyAtPosition(6, allMoves))
	{
		result = 6;
	}
	else if ((((playerMoves + 128) & 896) == 896 || ((playerMoves + 128) & 146) == 146 || ((playerMoves + 128) & 168) == 168) && !moveAlreadyAtPosition(7, allMoves))
	{
		result = 7;
	}
	else if ((((playerMoves + 256) & 292) == 292 || ((playerMoves + 256) & 896) == 896) && !moveAlreadyAtPosition(8, allMoves))
	{
		result = 8;
	}
	else if ((((playerMoves + 512) & 896) == 896 || ((playerMoves + 128) & 546) == 546 || ((playerMoves + 128) & 548) == 548) && !moveAlreadyAtPosition(9, allMoves))
	{
		result = 9;
	}
	else if (((aiMoves + 2) && !moveAlreadyAtPosition(1, allMoves)))
	{
		result = 1;
	}
	else if (((aiMoves + 4) && !moveAlreadyAtPosition(2, allMoves)))
	{
		result = 2;
	}
	else if (((aiMoves + 8) && !moveAlreadyAtPosition(3, allMoves)))
	{
		result = 3;
	}
	else if (((aiMoves + 16) && !moveAlreadyAtPosition(4, allMoves)))
	{
		result = 4;
	}
	else if (((aiMoves + 32) && !moveAlreadyAtPosition(5, allMoves)))
	{
		result = 5;
	}
	else if (((aiMoves + 64) && !moveAlreadyAtPosition(6, allMoves)))
	{
		result = 6;
	}
	else if (((aiMoves + 128) && !moveAlreadyAtPosition(7, allMoves)))
	{
		result = 7;
	}
	else if (((aiMoves + 256) && !moveAlreadyAtPosition(8, allMoves)))
	{
		result = 8;
	}
	else if (((aiMoves + 512) && !moveAlreadyAtPosition(9, allMoves)))
	{
		result = 9;
	}

	return result;
}

void applyMove(char currentPlayer, int currentMove, int& xMoves, int& oMoves)
{
	if (currentPlayer == 'X')
	{
		xMoves += pow(2, currentMove);
	}
	else
	{
		oMoves += pow(2, currentMove);
	}
}

void checkForWinner(bool& gameOver, int xMoves, int oMoves)
{
	if ((xMoves & 14) == 14 ||
		(xMoves & 112) == 112 ||
		(xMoves & 896) == 896 ||
		(xMoves & 546) == 546 ||
		(xMoves & 584) == 584 ||
		(xMoves & 292) == 292 ||
		(xMoves & 146) == 146 ||
		(xMoves & 168) == 168)
	{
		cout << "X wins" << endl;
		displayGameBoard(xMoves, oMoves);
		gameOver = true;
	}
	else if ((oMoves & 14) == 14 ||
		(oMoves & 112) == 112 ||
		(oMoves & 896) == 896 ||
		(oMoves & 546) == 546 ||
		(oMoves & 584) == 584 ||
		(oMoves & 292) == 292 ||
		(oMoves & 146) == 146 ||
		(oMoves & 168) == 168)
	{
		cout << "O wins" << endl;
		displayGameBoard(xMoves, oMoves);
		gameOver = true;
	}
	else if (((oMoves | xMoves) & 1022) == 1022)
	{
		cout << "CAT wins" << endl;
		gameOver = true;
	}
}